globals
[
simulation
plots-for-sale                                                            ;;; counts number of plots set up for sale each year
total-plots-sold                                                          ;;; counts number of plots that actually sold in that year
total-plots-unsold
plots-unsold-this-tick
reservation-not-met
plots-sold-this-tick
land-price                          
price-crop
yield-crop                         
year
tot-vc-prodn
avg-vc-prodn 
tot-prodn-crop
avg-prodn-crop
tot-crop-revenue
avg-crop-revenue
avg-cost-prodn 
tot-cost-prodn
current-plot-bid-on
current-list-of-bids
current-winning-bid
current-winner
price-paid
highest-bid
second-highest-bid
adj-winning-bid
list-of-winning-bids-adj
all-prices
auction-winner
auction-seller
auction-plot-acres
auction-plot-quality
auction-plot-location                                                ;;; xcor ycor for easy calculation of distance to bidders farmsteads'
past-crop-prices                                                     ;;; array of past crop prices, most recent first
past-crop-yields                                                     ;;; array of past crop yields, most recent first
xloc
yloc
bidders
land-for-sale?
dead
retired-exit
voluntary-exit
forced-exit
credit-constrained
]


turtles-own
[
age
generation
risk-aversion
urgency
skill
attitude
years-retired
average-multiplier
average-soil-quality
buyer?
exit
type-of-exit                                                      ;;; 0 = no exit, 1 = retirement, 2 = voluntary, 3 = forced
plots-owned
plot-for-sale  
plots-sold
plots-purchased     
land-value
capital-value
asset-value
equity-value
debt                                                                ;;; current debt remaining at year end
cash
NCFBI                                                               ;;; crop-revenue - tc-prodn - debt-payment-amount - family-withdrawal
list-NCFBI
years-paid-debt                                                     
principal                                                           ;;; current at year end (refers to last starting principal amount after a purchase)
debt-payment-amount                                                 ;;; payment that is due at the end of next harvest (at year end this refers to coming year)
principal-paid                                                      ;;; amount of principal paid to date (at year end this refers to yr that just ended)
capital-purchases
expected-production-volume
residual-to-land-labor
residual-to-land-labor-exp
acres-total-crop
prodn-crop
crop-revenue  
tc-prodn
variable-prodn-costs  
hired-labour    
travel-cost   
trucking-cost     
family-withdrawal
capital-replacement-charge 
;avgall-adj-prodn-volume   
years-neg-ncfbi   
years-neg-cash   
credit-constrained? 
active-bidder?
times-bid
winning?
winner?
won-last                                                            ;;; 0 = na, 1 = true, 2 = false
winning-bids
expected-price                                                      ;;; expected price based on 3 yr weighted moving average of past crop prices
expected-yield                                                      ;;; expected yield based on 3 yr weighted moving average of past crop yields
expected-price-per-acre-adj
distance-to-plot-bid-on
expected-variable-prodn-costs
expected-hired-labour-cost
expected-transport-cost
expected-capital-replacement-charge
expected-netrev-per-acre
initial-capital-investment 
expected-gross-rev
expected-net-revenue
expected-salvage-value
annuity     
local-price-info
global-price-info 
max-bid-per-acre
max-bid
max-bid-credit-constraint
value-of-land-bid-on-per-acre
value-of-land-bid-on
bid
current-bid
abs-max-bid   
error2         
initial-parameters  
list-prices  
std-dev-land   
upper-bound     
lower-bound                         
]

patches-own
[
annual-multiplier
patch-id
owner
farmstead?
for-sale?
quality
k-acres
distance-to-farmstead
rain
prodn-volume   
on-auction-block?
reservation-price
times-sold
expected-price-p
expected-yield-p
expected-price-per-acre-adj-p
expected-gross-rev-p
expected-variable-prodn-costs-p
expected-hired-labour-cost-p
expected-transport-cost-p
expected-capital-replacement-charge-p
expected-netrev-p
initial-capital-investment-p
expected-salvage-value-p
annuity-p
]

breed [farmers a-farmer]
breed [retirees retired]


  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; initialization-phase-control ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to initialization-phase-control


            
      if user-yes-or-no? "Have Output Files Been Initialized?"
               [ setup ]
            
 
  
end

to setup


ca
clear-output
create-plots
initialize-farm-agents
import-crop-arrays
delete-files
set simulation 1 
prepare-output-files
user-message "initialization complete"
    
end

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; RESET MODEL ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to reset
 
 clear-all-plots
 clear-drawing 
 clear-output
 cp
 ct 
 ask turtles [die]
  set plots-for-sale 0                                                          
  set total-plots-sold 0                                                        
  set total-plots-unsold 0
  set plots-unsold-this-tick 0
  set reservation-not-met 0
  set plots-sold-this-tick 0
  set land-price 0                         
  set price-crop 0
  set yield-crop 0                        
  set year 0
  set tot-vc-prodn 0
  set avg-vc-prodn 0
  set tot-prodn-crop 0
  set avg-prodn-crop 0
  set tot-crop-revenue 0
  set avg-crop-revenue 0
  set avg-cost-prodn 0
  set tot-cost-prodn 0
  set current-plot-bid-on 0
  set current-list-of-bids 0
  set current-winning-bid 0
  set current-winner 0
  set price-paid 0
  set highest-bid 0
  set second-highest-bid 0
  set adj-winning-bid 0
  set list-of-winning-bids-adj 0
  set all-prices 0
  set auction-winner 0
  set auction-seller 0
  set auction-plot-acres 0
  set auction-plot-quality 0
  set auction-plot-location 0                                               
  set past-crop-prices 0                                                    
  set past-crop-yields 0                                                    
  set xloc 0
  set yloc 0
  set bidders 0
  set land-for-sale? 0
  set dead 0
  set retired-exit 0
  set voluntary-exit 0
  set forced-exit 0

 end

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CREATE PLOTS  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


to create-plots

  assign-patch-id
  clear-land-tenure
  set-quality-and-cultivated-acres
  
   
end

to assign-patch-id

let counter []
set counter 1
  ask patches [without-interruption [set patch-id counter set counter counter + 1]]
  ask patches [ set pcolor black]
  
end      
        

to clear-land-tenure 

set current-plot-bid-on []
ask patches [set owner "NA" 
             set for-sale? true
             set farmstead? false
             set on-auction-block? false
            ]        
        
end        

to set-quality-and-cultivated-acres

  ask patches [set quality random-normal 1 0.05]                                           
    diffuse quality 0.75 
  ask patches [set quality precision quality 2] 
  ask patches [set pcolor green]                
  ask patches [set k-acres random-normal 150 15]
    diffuse k-acres 0.5
  ask patches [set k-acres precision k-acres 0]   
  ask patches with [ k-acres > 160 ][set k-acres 160]
  ask patches [set times-sold 0]
  
end

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CREATE FARM AGENTS  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
  to initialize-farm-agents
 
   create-farm-agents
   assign-farm-agent-attributes
   create-retirees                                                                                                            
         
 end     

 to create-farm-agents
 
   create-farmers 422
   ask farmers [set color red]  
   ask farmers [set type-of-exit 0]
   ask farmers [set skill random-normal 1 0.05]                    
   ask farmers with [ skill > 1.2][set skill 1.2] ;; check this again for new bounds
   ask farmers [set skill precision skill 2]
   ask farmers [set land-value 0]
   ask farmers [set asset-value 0]
   ask farmers [set debt 0]
   ask farmers [set principal 0]
   ask farmers [set years-paid-debt 0]
   ask farmers [set list-NCFBI ["x" "x" "x" "x" "x"]]
   ask farmers [setxy random-xcor random-ycor]                                               
   ask farmers [if any? other-turtles-here [ find-new-spot ]] 
   ask farmers [set xcor pxcor-of patch-at 0 0]  
   ask farmers [set ycor pycor-of patch-at 0 0] 
   ask farmers [set owner-of (patch-at 0 0) who]                                   
   ask farmers [set buyer? "NA"]
   ask farmers [set credit-constrained? "NA"]
   ask farmers [set won-last 0]
   ask farmers [set winning-bids []]
   ask farmers [set capital-purchases []]
   ask farmers [set active-bidder? false set plots-purchased 0 set plots-sold 0]
   ask patches with [owner != "NA"][set for-sale? false] 
   ask patches with [owner != "NA"][set farmstead? true]
           
     
 end
 
 to assign-farm-agent-attributes                                    
 
   ask farmers
      [
       set generation 1
       
       if Type-of-Auction = "TPSB"
       [       
       set local-price-info [ 453.07	470.33	429.67	489.05	483.30	412.91 ]                            
       set global-price-info [ 386.19	489.70	430.60	469.52	411.88	409.35 ]    
       ]
        
        if Type-of-Auction = "FPSB"
       [       
       set local-price-info [ 418.44	438.81	502.74	510.69	435.78	448.48 ]                            
       set global-price-info [ 439.46	450.97	479.83	493.07	455.44	433.01 ]    
       ]
       
       if Type-of-Auction = "SPSB"
       [       
       set local-price-info [ 339.37	345.83	406.06	387.53	453.77	468.30 ]                            
       set global-price-info [ 468.66	416.59	377.23	347.46	439.05	439.31 ]	     	
       ]
       
       if Type-of-Auction = "English"
       [       
       set local-price-info [ 397.11	489.25	559.01	418.57	460.15	534.89 ]                      
       set global-price-info [ 389.97	458.63	410.42	441.13	472.89	503.52 ]
       ]         
                     
      ]                                                                   
      
 
   let initial-parameters3 [
   
   [	20	22	129369.1545	]
[	20	14	235265.8787	]
[	20	14	278357.6685	]
[	20	6	108191.5533	]
[	20	6	92694.01576	]
[	20	13	199470.3016	]
[	20	19	297549.2029	]
[	20	8	66006.29616	]
[	20	8	179743.3923	]
[	20	11	71479.48545	]
[	20	12	162996.0983	]
[	20	14	233680.0404	]
[	20	14	305471.8716	]
[	20	14	146780.9561	]
[	20	20	103999.5164	]
[	20	20	329014.0366	]
[	20	10	60908.35853	]
[	20	10	161966.8128	]
[	20	12	148726.4225	]
[	20	13	182743.0625	]
[	21	13	260170.5799	]
[	22	13	193656.6819	]
[	22	13	196578.8386	]
[	22	14	325727.5125	]
[	22	14	246525.0256	]
[	22	6	44810.81549	]
[	23	6	109971.927	]
[	23	7	41351.87027	]
[	23	8	214626.478	]
[	24	8	126254.592	]
[	24	14	87545.19911	]
[	24	14	209291.0255	]
[	24	2	33572.65475	]
[	24	5	53637.46559	]
[	24	13	203168.3772	]
[	24	13	135626.6554	]
[	24	17	251945.9082	]
[	24	24	344785.1374	]
[	25	25	681282.9724	]
[	25	7	93038.20153	]
[	25	7	2843.572495	]
[	25	12	381641.276	]
[	25	16	229376.417	]
[	25	16	369558.8964	]
[	26	17	279824.5903	]
[	26	18	374711.2974	]
[	26	18	154349.009	]
[	26	1	21179.21189	]
[	26	1	13825.10917	]
[	26	4	71643.96728	]
[	26	4	82707.42389	]
[	26	9	102735.8476	]
[	27	10	277477.8832	]
[	27	11	176065.1241	]
[	27	15	463548.2161	]
[	27	20	134553.2758	]
[	27	20	416949.637	]
[	27	1	12213.09929	]
[	27	4	36813.58937	]
[	27	4	126014.4607	]
[	27	4	82446.89796	]
[	27	4	89298.11716	]
[	27	4	115257.5152	]
[	28	15	304488.725	]
[	28	15	36201.37024	]
[	28	17	277029.0302	]
[	28	17	240521.9325	]
[	28	2	9159.021635	]
[	28	8	43561.6694	]
[	28	15	284781.6019	]
[	29	16	277137.2871	]
[	29	16	297336.1244	]
[	29	16	292963.8361	]
[	29	16	48345.07359	]
[	29	22	935590.3677	]
[	29	5	54437.8794	]
[	29	5	68231.22493	]
[	29	8	3735.432792	]
[	29	8	166459.5711	]
[	29	9	117313.2155	]
[	29	9	74115.14825	]
[	30	12	170261.7681	]
[	30	12	134582.7438	]
[	30	12	369825.2921	]
[	30	13	108478.9505	]
[	30	13	129999.8798	]
[	30	22	211913.8654	]
[	30	22	287767.136	]
[	30	2	24590.84212	]
[	30	2	41757.34812	]
[	30	5	143960.6088	]
[	30	6	135904.0212	]
[	31	6	69787.59318	]
[	31	7	118270.7711	]
[	31	7	4558.538341	]
[	31	7	150163.1238	]
[	31	8	173813.6419	]
[	31	9	263823.7427	]
[	31	9	212660.9294	]
[	31	10	95772.9738	]
[	31	10	170897.9829	]
[	31	11	128165.5802	]
[	31	11	48094.68678	]
[	32	15	0	]
[	32	15	186903.5969	]
[	32	1	21741.44727	]
[	32	1	29431.33741	]
[	32	3	78928.9241	]
[	32	3	61008.55333	]
[	32	7	90734.47005	]
[	32	7	146302.6175	]
[	33	7	120249.7191	]
[	33	7	97506.14128	]
[	33	9	118371.5355	]
[	33	14	273666.6959	]
[	33	14	279139.1963	]
[	33	14	313722.4797	]
[	33	16	441635.4146	]
[	33	17	173106.4618	]
[	33	17	321343.4612	]
[	33	18	481351.4966	]
[	33	18	260798.0268	]
[	34	25	545961.4922	]
[	34	1	16187.77246	]
[	34	1	13403.60633	]
[	34	1	33435.00519	]
[	34	2	27384.10639	]
[	34	3	30456.1036	]
[	34	3	38834.40084	]
[	34	4	34357.22908	]
[	34	6	38613.19372	]
[	34	6	79350.90945	]
[	34	6	133946.4938	]
[	34	6	178914.1755	]
[	34	6	15212.79423	]
[	34	6	143497.6919	]
[	34	7	38386.89821	]
[	34	7	218176.4536	]
[	35	8	66601.66728	]
[	35	8	158327.8327	]
[	35	9	252051.9969	]
[	35	10	207493.547	]
[	35	10	90488.26083	]
[	35	10	222877.8869	]
[	35	11	179704.8558	]
[	35	11	290429.5982	]
[	35	11	164919.6361	]
[	35	13	314093.5511	]
[	35	13	299417.0541	]
[	35	13	72759.55542	]
[	35	14	124104.3615	]
[	35	15	302658.3049	]
[	35	15	259314.9102	]
[	35	15	498407.3968	]
[	36	16	468666.7367	]
[	36	17	60465.91802	]
[	36	18	353422.2965	]
[	36	18	345725.6354	]
[	36	18	239102.2914	]
[	36	1	3143.486799	]
[	36	1	5934.279368	]
[	36	2	41091.81962	]
[	36	4	101083.2577	]
[	36	6	219266.0355	]
[	36	6	107737.4978	]
[	36	6	105798.9214	]
[	36	6	75690.4618	]
[	36	6	56295.44065	]
[	36	9	175388.5952	]
[	36	9	199556.7559	]
[	36	10	128298.3581	]
[	36	10	159722.7703	]
[	36	10	141025.4942	]
[	36	12	117569.137	]
[	37	12	147792.2677	]
[	37	12	225982.2785	]
[	37	13	88059.93814	]
[	37	13	106676.1058	]
[	37	14	248085.9194	]
[	37	14	183062.2835	]
[	37	14	158388.6988	]
[	37	15	309150.9396	]
[	37	16	470821.9262	]
[	37	17	0	]
[	37	19	482540.84	]
[	37	21	361998.5426	]
[	37	27	701714.9456	]
[	37	28	348854.1876	]
[	37	3	31539.12148	]
[	38	3	42763.53702	]
[	38	4	57094.71247	]
[	38	4	11346.77974	]
[	38	5	126536.3766	]
[	38	6	140785.1019	]
[	38	6	92943.82135	]
[	38	6	16798.89207	]
[	38	7	0	]
[	38	8	121249.9061	]
[	38	8	184363.5617	]
[	38	10	117194.6517	]
[	38	11	126331.0586	]
[	38	11	37312.78666	]
[	38	13	241788.391	]
[	38	13	176996.0474	]
[	38	14	156541.0473	]
[	38	14	264129.4589	]
[	38	15	123477.7932	]
[	39	16	298870.5828	]
[	39	17	209613.3181	]
[	39	17	433019.5695	]
[	39	19	303097.0536	]
[	39	19	377583.0552	]
[	39	19	24606.41171	]
[	39	20	355743.2501	]
[	39	20	453881.8405	]
[	39	20	453692.2285	]
[	39	21	257393.8794	]
[	39	21	300508.4433	]
[	39	25	708884.0466	]
[	39	28	475644.3189	]
[	39	5	57142.43641	]
[	39	6	76501.96541	]
[	39	6	39591.48737	]
[	39	6	35087.13437	]
[	39	6	22150.36519	]
[	39	6	122761.3175	]
[	39	7	70064.77619	]
[	40	10	202355.2864	]
[	40	10	127816.2044	]
[	40	11	226633.8578	]
[	40	11	244547.7581	]
[	40	11	116280.9498	]
[	40	11	38129.95382	]
[	40	11	186860.8049	]
[	40	12	124080.4708	]
[	40	12	185737.8471	]
[	40	12	248588.9993	]
[	40	13	227935.0292	]
[	40	14	268201.4558	]
[	40	14	84455.48012	]
[	40	14	313243.3105	]
[	40	14	122814.3993	]
[	40	15	318543.8396	]
[	40	15	261419.7813	]
[	40	15	220393.7524	]
[	41	15	121999.6865	]
[	41	25	382181.2237	]
[	41	27	166417.295	]
[	41	2	40122.61932	]
[	41	2	42207.59631	]
[	41	5	46076.63066	]
[	41	6	76404.60576	]
[	41	6	67430.90822	]
[	41	7	89556.58296	]
[	41	7	145178.6244	]
[	41	10	131173.7893	]
[	41	13	461110.2195	]
[	41	13	156472.3561	]
[	41	13	294174.7333	]
[	41	15	304567.1532	]
[	41	15	492336.371	]
[	41	15	317396.0622	]
[	41	16	132207.4043	]
[	41	20	348790.6715	]
[	41	20	450214.7235	]
[	42	3	39884.92031	]
[	42	3	71935.58917	]
[	42	4	99509.06256	]
[	42	4	45753.26761	]
[	42	5	104337.9834	]
[	42	10	248230.2382	]
[	42	10	194384.5843	]
[	42	10	193451.2591	]
[	42	13	0	]
[	42	13	350251.6146	]
[	42	16	333313.6645	]
[	42	16	126195.7627	]
[	42	17	427229.7984	]
[	42	17	248621.3012	]
[	42	19	378329.2918	]
[	42	21	632910.7176	]
[	42	15	391786.8703	]
[	42	11	248379.4086	]
[	42	11	190105.3099	]
[	43	11	237408.6127	]
[	43	13	393446.9887	]
[	43	13	388981.0545	]
[	43	5	115962.3133	]
[	43	10	125011.3402	]
[	43	10	178489.4947	]
[	43	3	74419.13905	]
[	43	3	7339.818308	]
[	43	7	71070.37207	]
[	43	7	28191.58521	]
[	43	11	172486.1012	]
[	43	12	297503.637	]
[	43	3	0	]
[	43	4	59747.69425	]
[	43	4	65191.24623	]
[	43	7	87359.8758	]
[	44	9	42744.67719	]
[	44	10	77597.45147	]
[	44	10	261643.5746	]
[	44	12	148315.114	]
[	44	12	253784.5493	]
[	44	21	138580.2369	]
[	44	3	6356.579302	]
[	44	3	63545.11556	]
[	44	6	44119.532	]
[	44	6	142312.1633	]
[	44	7	67823.06665	]
[	44	10	318881.9124	]
[	44	10	134294.4413	]
[	44	2	37279.07641	]
[	44	2	50432.39913	]
[	44	14	404538.1493	]
[	44	4	75542.79066	]
[	45	4	74525.08088	]
[	45	8	18026.63006	]
[	45	9	21163.63869	]
[	45	9	43610.3301	]
[	45	12	387395.8287	]
[	45	16	116069.2173	]
[	45	16	316234.7986	]
[	45	18	354929.938	]
[	45	19	163748.7937	]
[	45	19	461436.4336	]
[	45	22	747572.4363	]
[	45	22	143842.1904	]
[	45	23	581320.9598	]
[	45	24	371294.5586	]
[	46	22	231281.0148	]
[	46	3	47337.90205	]
[	46	5	82577.67497	]
[	46	8	33476.80314	]
[	46	8	193796.3519	]
[	46	4	114063.1724	]
[	46	4	30776.26069	]
[	46	4	73016.02902	]
[	46	6	0	]
[	46	6	163732.3563	]
[	46	6	118741.3838	]
[	46	7	180166.2369	]
[	46	7	213071.8402	]
[	46	2	32359.63263	]
[	46	2	30100.38974	]
[	46	4	95062.32418	]
[	46	4	42734.10455	]
[	47	4	40935.60655	]
[	47	4	88951.07063	]
[	47	5	117865.8525	]
[	47	8	198604.333	]
[	47	8	157743.6838	]
[	47	1	19512.16023	]
[	47	1	12844.51594	]
[	47	2	34492.5899	]
[	47	2	20958.70451	]
[	47	2	35706.97857	]
[	47	4	75104.3291	]
[	47	4	56454.55318	]
[	47	4	60329.86041	]
[	47	9	137685.1023	]
[	48	9	158854.9487	]
[	48	1	19048.88127	]
[	48	1	23118.57371	]
[	48	2	22073.99078	]
[	48	7	73820.46224	]
[	48	7	50610.60663	]
[	48	7	132701.0815	]
[	48	7	127785.9706	]
[	48	8	202238.671	]
[	48	8	216218.5453	]
[	48	10	264462.3074	]
[	49	10	62901.76817	]
[	49	1	15873.5252	]
[	49	1	20409.19898	]
[	49	2	19868.02356	]
[	49	2	13818.3078	]
[	49	3	65534.94726	]
[	49	4	78054.76388	]
[	49	6	124214.0926	]
[	49	7	127967.9443	]
[	49	7	209759.9317	]
[	49	7	107031.5592	]
[	50	9	117582.3259	]
[	50	2	26640.00767	]
[	50	2	12633.8863	]
[	50	8	68572.1772	]
[	50	9	167002.5733	]
[	51	9	92673.4406	]
[	51	11	302425.5657	]
[	51	11	250796.6437	]
[	51	12	106521.396	]
[	51	12	205466.5777	]
[	51	2	22446.58992	]
[	51	2	71580.17722	]
[	51	4	96517.05477	]
[	52	4	102309.5827	]
[	52	7	91617.20713	]
[	52	7	49066.05277	]
[	52	7	64726.50434	]
[	52	6	138338.8138	]
[	52	6	42789.47246	]
[	53	7	203953.993	]
[	53	8	119896.6545	]
[	54	8	255478.6121	]
[	54	10	0	]
[	55	14	65627.43636	]
[	56	14	260312.3243	]
[	57	4	80702.1732	]
[	58	5	66511.95181	]
[	58	5	124103.0212	]
[	58	6	33102.65755	]
[	59	7	138847.2535	]
[	59	8	187708.1368	]
[	60	8	84135.52541	]
[	61	2	0	]
[	61	2	31369.1492	]
[	64	4	10822.27104	]
[	65	9	66510.50852	]
[	66	1	13007.718	]
[	66	1	15024.22137	]]
 
   
   file-open "residual-to-land-labor.txt"
   ask farmers [set residual-to-land-labor-exp file-read]
   file-close
   
   file-open "expected-crop-volume.txt"
   ask farmers [set expected-production-volume file-read]
   file-close
   
   foreach initial-parameters3 [
   
   ask farmers [
     set age item 0 initial-parameters
     set plots-owned item 1 initial-parameters
     set debt precision(item 2 initial-parameters)2
     set debt precision(debt * 1.15)2
     if age < 20 [set age 20]
   ]  ]
   
    
   ask farmers [own]
                       
   ask farmers [if age <= 30 [set attitude 3]]                                                                    ;;; least risk averse
   ask farmers [if (age > 30 and age <= 40) [set attitude 2]]                                                     ;;; 
   ask farmers [if (age > 40) [set attitude 1]]                                                                   ;;; most risk averse
   
   ask farmers [set urgency 1]
   
   
   ask farmers [set years-paid-debt 1]                   
   ;;; This assumes that all loans were refinanced in t = 0                              
   ask farmers [set principal debt]                               
   ask farmers [set debt-payment-amount precision(principal * (Int-Rate / (1 - (1 / (1 + Int-Rate)^ repayment))))0]
   ask farmers [set principal-paid precision(debt-payment-amount - (principal * Int-Rate))0
               set debt debt - principal-paid]
    
   ask farmers [set acres-total-crop sum values-from patches with [owner = who-of myself][k-acres]]              
   ask farmers [set capital-value (capital-per-acre * acres-total-crop)]
   ask farmers [set cash precision(cash-per-acre * acres-total-crop)0]
   
end

to find-new-spot

      fd random 20 
      if not can-move? 1
      [ rt random 180 ]       
      fd random 15                                                      
      if any? other-turtles-here [find-new-spot]  
end

to own

  if ((count patches with [owner = who-of myself]) < plots-owned)[find-land]

end


to find-land
    
  without-interruption [ask min-one-of patches with [for-sale? = true][(abs(pxcor - xcor-of myself) + abs(pycor - ycor-of myself))]           
      [set owner who-of myself
       set distance-to-farmstead distancexy xcor-of turtle owner ycor-of turtle owner
       set for-sale? false
       
       ]]
       
  if ((count patches with [owner = who-of myself])< plots-owned)[find-land]
  
end

to create-retirees

  ask farmers [if age >= 65 [set breed retirees]]
  ask n-of (percentage-retired * 422) farmers with [age > 60] [set breed retirees]                           
  ask retirees 
  [
    set color black 
    set exit true
    set type-of-exit 1
    set years-retired 1
    set attitude 3 
    set urgency 0.85
    set won-last 0
    ask patches with [owner = who-of myself]
     [  set for-sale? true
        set pcolor blue
        set farmstead? false
     ]
  ]
  
end

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; ASSIGN PARAMETERS  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  
to import-crop-arrays
   
  file-open "yield crop.txt"
  set yield-crop file-read
  file-close
  
  file-open "past crop yield.txt"
  set past-crop-yields file-read
  file-close
  
  import-price-arrays

end
  
to import-price-arrays
  
  file-open "price crop.txt"
  set price-crop file-read
  file-close
  
  file-open "past crop price.txt"
  set past-crop-prices file-read
  file-close
  
  if Type-of-Auction = "TPSB"
       [       
       set list-of-winning-bids-adj [	445.43	443.58	440.80	411.37	474.14	379.31	414.69	477.17	465.46								
	                                    361.86	398.46	413.82	396.28	501.12	502.99	426.78	443.93	362.56								
	                                    431.14	376.16	"x"	"x" "x" "x" "x" "x" "x" "x" "x" "x" "x" "x" "x" "x"
	                                    "x" "x" "x" "x" "x" "x"	]

       ]
        
  if Type-of-Auction = "FPSB"
       [       
       set list-of-winning-bids-adj [	420.60	509.19	464.36	491.95	457.52	474.45	457.16	424.06	422.57					
	                                    435.03	463.30	440.00	490.34	454.14	481.35	482.71	438.35	430.11					
	                                    457.07	486.77	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	
	                                    "x"	"x"	"x"	"x"	"x"	"x"	]					

       ]
       
  if Type-of-Auction = "SPSB"
       [       
       set list-of-winning-bids-adj [	385.31	459.87	345.24	356.71	398.99	384.87	454.83	370.96	410.55	
                                      340.92	355.20	360.14	351.59	323.47	467.77	440.71	405.29	419.86	
                                      433.11	464.87	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	
                                      "x"	"x"	"x"	"x"	"x"	"x"	]


       ]
       
  if Type-of-Auction = "English"
       [       
       set list-of-winning-bids-adj [	494.59	527.13	554.63	460.17	558.53	503.82	511.33	507.25	425.09					
	                                    405.13	489.72	469.35	492.39	477.63	519.56	488.65	406.47	480.78					
	                                    546.90	486.34	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"	"x"
	                                    "x"	"x"	"x"	"x"	"x"	"x"	]

       ]
                
                                                     
  set all-prices list-of-winning-bids-adj    
    ;;; this will be used when learning is off.                                                                                   
   
  ask farmers [set land-value precision((sum values-from patches with [owner = who-of myself ][k-acres * quality]) * mean list-of-winning-bids-adj)0]
  ask farmers [set asset-value precision(land-value + capital-value + cash)0] 
  ask farmers [set equity-value precision (asset-value - debt)0]              
    
end
  
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; SIMULATION PHASE CONTROL  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


to simulation-phase

  set year year + 1
  
  update-retirees-parameters
  update-farmers-parameters
  crop-production-module
  farm-accounting-module
  form-expectations
  continue-farming-module?    
  farm-expansion-contraction
  reservation-price-calculation-module
  land-purchase-auction-module  
  export-data                             
  ifelse year < simulation-length
     [simulation-phase]   
     [ifelse simulation < number-of-simulations
       [  set simulation simulation + 1
          reset
          create-plots
          initialize-farm-agents
          import-crop-arrays
          simulation-phase
      ]                                                     
      [user-message "complete"]
     ]  
end

to update-retirees-parameters

  ask retirees
      [
        set years-retired (years-retired + 1)
        set color black 
        set exit true
        ask patches with [owner = who-of myself]
         [  
            set for-sale? true
            set pcolor blue
            set farmstead? false
         ]
        if years-retired <= 2 [set attitude 3 set urgency 0.85]                                                                    
        if (years-retired > 2 and years-retired <= 5) [set attitude 2 set urgency 0.75]                                                     
        if (years-retired > 5) [set attitude 1 set urgency 0.65]   
        ;;; maybe this should be a function of farmsize as well? Small farms more urgent.
        ;;; Dick says yes, Peter and I say no.                                                               
   
     ]  
end


to update-farmers-parameters

   error-calculation

   ask farmers [if age <= 30 [set attitude 3]]                                                                    ;;; least risk averse
   ask farmers [if (age > 30 and age <= 40) [set attitude 2]]                                                     ;;; 
   ask farmers [if (age > 40) [set attitude 1]]                                                                   ;;; most risk averse
   
   ask farmers [if attitude = 3[set risk-aversion 0.95]]                                                          
   ask farmers [if attitude = 2[set risk-aversion 0.90]]                                                          ;;; risk avesion parameters used in bidding
   ask farmers [if attitude = 1[set risk-aversion 0.85]]
   
end
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CROP PRODUCTION MODULE  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to crop-production-module

  simulate-crop-revenue
  simulate-variable-prodn-costs
  simulate-hired-labour-cost
  simulate-transport-cost
  simulate-capital-replacement-charge
  simulate-living-deductions
  set-net-cash-flow-before-investment
  
    
end

   
to simulate-crop-revenue

  set tot-vc-prodn 0                                                                                            ;;; these are values for ALL AGENTS in the simulation
  set avg-vc-prodn 0                                                                                            ;;; used to keep track of aggregate totals
  set tot-prodn-crop 0
  set avg-prodn-crop 0
  set tot-crop-revenue 0
  set avg-crop-revenue 0
  
  ask patches [set rain random-normal 1 0.05]                                           
    diffuse rain 0.75
  ask patches [set rain precision rain 2]     
  
  ask patches [set annual-multiplier rain * quality]                                                                                                ;;; calculates yield multiplier (annual and fixed growing condition) 
  ask farmers [set acres-total-crop sum values-from patches with [owner = who-of myself][k-acres]]                                                  ;;; calculates total crop acreage of farm
  ask farmers [set average-multiplier 
              precision ((sum values-from patches with [owner = who-of myself][annual-multiplier * k-acres]) / acres-total-crop) 2]   
  ask farmers [set average-soil-quality 
              precision ((sum values-from patches with [owner = who-of myself][quality * k-acres]) / acres-total-crop)2]
                
  ask farmers [set prodn-crop precision (acres-total-crop * average-multiplier * skill * (item (year) yield-crop))2]                                ;;; calculates volume of production in tonnes for all k-acres owned of crop 
  
  set tot-prodn-crop sum values-from turtles [prodn-crop]                                                                                           ;;; calculates the total production by all agents
  set avg-prodn-crop (tot-prodn-crop / 422)                                                                                                         ;;; calculates the average production by all agents
  
  ask farmers [set crop-revenue precision (prodn-crop * (item (year) price-crop))2]                                                                 ;;; calculates crop revenue
  
  set past-crop-prices fput (item (year) price-crop) past-crop-prices                                                                               ;;; adds current crop price to a vector of past prices
  set past-crop-prices but-last past-crop-prices
  set past-crop-yields fput (item (year) yield-crop) past-crop-yields                                                                               ;;; adds current crop yield to a vector of past yields 
  set past-crop-yields but-last past-crop-yields
            
            
            
  set tot-crop-revenue sum values-from turtles [crop-revenue]                                                                                       ;;; calculates total crop revenue for all agents
  set avg-crop-revenue (tot-crop-revenue / 422)                                                                                                     ;;; calculates average crop revenue for all agents
  
  ask farmers [ask patches with [owner = who-of myself][set prodn-volume (annual-multiplier / average-multiplier-of myself) *                       ;;; calculates volume of production on each plot of land (TOTAL: ALL K ACRES)
                                                                        (prodn-crop-of myself / acres-total-crop-of myself) *                       
                                                                         k-acres]]   
                                                                         
end


to simulate-variable-prodn-costs

  ask farmers [set variable-prodn-costs precision (acres-total-crop * per-acre-vc)0] 
  set tot-vc-prodn sum values-from turtles [variable-prodn-costs]                                                                            
  set avg-vc-prodn (tot-vc-prodn / 422)  
  
end


to simulate-hired-labour-cost

  ask farmers [set hired-labour precision ((((0.8 / (1 + 14500 * exp (-0.009 * acres-total-crop))) + 0.03) * acres-total-crop) * 6.75)0]
  

end


to simulate-transport-cost

  ask farmers [set travel-cost (sum values-from patches with [owner = who-of myself][distance-to-farmstead]) * travel-adjustment]
  ask farmers [set trucking-cost precision (sum values-from patches with [owner = who-of myself]                                                                                         
            [prodn-volume * distance-to-farmstead] * trucking-rate)0]
            
end


to simulate-capital-replacement-charge

  ask farmers [set capital-replacement-charge capital-value * depreciation-rate]

end

to simulate-living-deductions
   
  ask farmers [set family-withdrawal precision(min-family-withdrawal + 0.068 * crop-revenue + 125 * (plots-owned))0]
  
  
end

to set-net-cash-flow-before-investment
  set tot-cost-prodn 0                                                                                                                                   
  set avg-cost-prodn 0
  ask farmers [ set tc-prodn 0]
  ask farmers [ set tc-prodn (variable-prodn-costs + hired-labour + travel-cost + trucking-cost + capital-replacement-charge)]
  ask farmers [ if debt = 0  
              [set NCFBI  precision(crop-revenue - tc-prodn - debt-payment-amount - family-withdrawal)0]]
  ask farmers [ if debt > 0 and debt >= debt-payment-amount 
              [set NCFBI  precision(crop-revenue - tc-prodn - debt-payment-amount - family-withdrawal)0]]
  ask farmers [ if debt > 0 and debt < debt-payment-amount
              [set NCFBI  precision(crop-revenue - tc-prodn - debt - family-withdrawal)0]]
  ask farmers [set cash (cash + NCFBI)]
  ask farmers [set list-NCFBI fput NCFBI list-NCFBI]
  ask farmers [set list-NCFBI butlast list-NCFBI]
  
  ask farmers [ifelse (cash < 0)             ;;; This is not yet used.
                [set years-neg-cash years-neg-cash + 1][set years-neg-cash 0]]                                              
  ask farmers [if cash < 0 [ set debt (debt + (cash * -1)) set cash 0]] 
                                                               
  ask farmers [ifelse (NCFBI < 0) 
              [set years-neg-ncfbi years-neg-ncfbi + 1][set years-neg-ncfbi 0]]                                                             
  
  ask farmers [set principal-paid precision(debt-payment-amount - (principal * Int-Rate))0
               set debt debt - principal-paid]
  
  ask farmers [ if debt <= 0 
              [set debt 0 set principal 0 set debt-payment-amount 0 set years-paid-debt 0 set principal-paid 0]]
                                                                                                  
  set tot-cost-prodn sum values-from turtles [tc-prodn]
  set avg-cost-prodn mean values-from turtles [tc-prodn]
  
  
                     
end

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; FARM ACCOUNTING MODULE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to farm-accounting-module

  ask farmers [determine-land-market-value]
  ask farmers [determine-asset-value]
  ask farmers [determine-equity-value]

end

to determine-land-market-value
 
  set land-value precision((sum values-from patches with [owner = who-of myself ][k-acres * quality]) * mean list-of-winning-bids-adj)0 
                                  
end

to determine-asset-value

  set asset-value precision(land-value + capital-value + cash)0
  
end  

to determine-equity-value

  set equity-value precision (asset-value - debt)0
                  
end 


 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; EXPECTATIONS MODULE? ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to form-expectations

ask farmers [set residual-to-land-labor precision 
                   (((crop-revenue / average-soil-quality) 
                     - variable-prodn-costs 
                     - capital-replacement-charge
                     - (0.068 * crop-revenue)
                     - (125 * (plots-owned))) 
                     / acres-total-crop)2]
                     
  ask farmers [ifelse residual-to-land-labor >= residual-to-land-labor-exp 
                  [set residual-to-land-labor-exp (residual-to-land-labor-exp * (1 - expectation-weight)
                                                 + (expectation-weight * residual-to-land-labor))]                    
                  [set residual-to-land-labor-exp (residual-to-land-labor-exp * (1 - (1 * expectation-weight))
                                                 + ((1 * expectation-weight) * residual-to-land-labor))]]
  
  ask farmers [set expected-production-volume precision
                   ((expected-production-volume * (1 - expectation-weight))  +
                    (prodn-crop / average-soil-quality / acres-total-crop)* expectation-weight)0] 

  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; LAND PRICE EXPECTATION INFORMATION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ;;;;;;;;;;;;;;;;;;;;; USED FOR CALCULATING RESERVATION PRICE AND SALVAGE VALUE ;;;;;;;;;;;;;;;;;;;;;;;;
  
  if Information-Diffusion = "on"
  [ask patches
    [
       set expected-price-per-acre-adj-p (.7 * ((0.38 * item 0 local-price-info-of turtle owner) + 
                                                (0.28 * item 1 local-price-info-of turtle owner) +
                                                (0.16 * item 2 local-price-info-of turtle owner) +
                                                (0.08 * item 3 local-price-info-of turtle owner) +
                                                (0.07 * item 4 local-price-info-of turtle owner) +
                                                (0.03 * item 5 local-price-info-of turtle owner)) + .3 *  ((0.38 * item 0 global-price-info-of turtle owner) + 
                                                                                                           (0.28 * item 1 global-price-info-of turtle owner) +
                                                                                                           (0.16 * item 2 global-price-info-of turtle owner) +
                                                                                                           (0.08 * item 3 global-price-info-of turtle owner) +
                                                                                                           (0.07 * item 4 global-price-info-of turtle owner) +
                                                                                                           (0.03 * item 5 global-price-info-of turtle owner)))    
    ]
   ask turtles                                                                                                    
    [
       set expected-price-per-acre-adj   (.7 * ((0.38 * item 0 local-price-info) + 
                                                (0.28 * item 1 local-price-info) +
                                                (0.16 * item 2 local-price-info) +
                                                (0.08 * item 3 local-price-info) +
                                                (0.07 * item 4 local-price-info) +
                                                (0.03 * item 5 local-price-info)) + .3 *  ((0.38 * item 0 global-price-info) + 
                                                                                           (0.28 * item 1 global-price-info) +
                                                                                           (0.16 * item 2 global-price-info) +
                                                                                           (0.08 * item 3 global-price-info) +
                                                                                           (0.07 * item 4 global-price-info) +
                                                                                           (0.03 * item 5 global-price-info)))                
    ]
   ] 
   
   if Information-Diffusion = "off"
   [ask patches
    [
       let standard-dev standard-deviation all-prices
       let average mean all-prices
       set expected-price-per-acre-adj-p precision(random-normal average standard-dev)2                                                              
    ]
   ask turtles                                                                                                    
    [
       let standard-dev standard-deviation all-prices
       let average mean all-prices
       set expected-price-per-acre-adj precision(random-normal average standard-dev)2               
    ]
   ] 
 
  
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;; OUTPUT PRICE AND YIELD EXPECTATION INFORMATION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
  
   ask patches
   [
       set expected-price-p precision(((0.40 * (item 0 past-crop-prices))+(0.20 * (item 1 past-crop-prices))+
                                     (0.15 * (item 2 past-crop-prices)) + (0.15 * (item 3 past-crop-prices))+
                                     (0.10 * (item 4 past-crop-prices))) * (1 + error2-of turtle owner))2
       set expected-yield-p precision(((0.40 * (item 0 past-crop-yields))+(0.20 * (item 1 past-crop-yields))+
                                     (0.15 * (item 2 past-crop-yields)) + (0.15 * (item 3 past-crop-yields))+
                                     (0.10 * (item 4 past-crop-yields))) * (1 + error2-of turtle owner))2
   ]   
  ask turtles
     [
       set expected-price precision(((0.40 * (item 0 past-crop-prices))+(0.20 * (item 1 past-crop-prices))+
                                     (0.15 * (item 2 past-crop-prices)) + (0.15 * (item 3 past-crop-prices))+
                                     (0.10 * (item 4 past-crop-prices))) * (1 + error2))2     
       set expected-yield precision(((0.40 * (item 0 past-crop-yields))+(0.20 * (item 1 past-crop-yields))+
                                     (0.15 * (item 2 past-crop-yields)) + (0.15 * (item 3 past-crop-yields))+
                                     (0.10 * (item 4 past-crop-yields))) * (1 + error2))2      
     ]
  
 end
   
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CONTINUE FARMING MODULE? ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to continue-farming-module?                                                                                         
    
    ask farmers [set exit false]
    ask farmers [set buyer? "na"] 
                
    ask farmers with [ years-neg-cash = 0][set urgency 1]                                                                 
    ask farmers with [ years-neg-cash = 1][set urgency 0.80]
    ask farmers with [ years-neg-cash = 2][set urgency 0.60]
    ask farmers with [ years-neg-cash >= 3][set urgency 0.50]    
    ;;; years-neg-cash not yet used --> urgency not used for farmers yet either.      
    
    ask farmers with [(age >= 55) and (age < 60)][if (random 100 < retirement-tendency-55-59 * 100)  [set exit true set type-of-exit 1]]                                     
    ask farmers with [(age >= 60) and (age < 65)][if (random 100 < retirement-tendency-60-64 * 100)  [set exit true set type-of-exit 1]]
    ask farmers with [(age >= 65) and (age < 70)][if (random 100 < retirement-tendency-65-69 * 100)  [set exit true set type-of-exit 1]]
    ask farmers with [age >= 70]                 [if (random 100 < retirement-tendency-70-over * 100)[set exit true set type-of-exit 1]]
    ask farmers with [age >= 80]                                                                     [set exit true set type-of-exit 1]
         
    ask farmers with [exit = true] [if (random 100 < percent-pass-down and equity-value / asset-value > 0.6)  [set exit false set type-of-exit 0 next-generation]]       
                                    ;;; random X% of farmers with equity/asst > 60% pass down land
    
    ask farmers [if years-neg-ncfbi >= (random 5 + 5)[set exit true set type-of-exit 2]]                             ;;; Voluntary exit b/c of equity erosion
    ask farmers [if (debt) > (0.9 * asset-value)[set exit true set type-of-exit 3]]                                  ;;; Forced exit b/c of Insolvency                                                       
                                                                                                                                                                                                                      
   ask farmers with [exit = true]                                                                 
     [
      let to-print (list "1" simulation year who age breed type-of-exit generation skill attitude plots-owned average-soil-quality
                             risk-aversion debt asset-value years-neg-ncfbi "1")
     file-open "retiree-info.txt"    
     file-print to-print                                                                                   
     file-close 
     
    set breed retirees
    set color black
    set years-retired 1
    set attitude 3 
    set urgency 0.85
    ask patches with [owner = who-of myself]
     [  
        set for-sale? true
        set pcolor blue
        set farmstead? false
     ]
   ]     
   
 end  
 
 to next-generation                                                                                                      
            
  without-interruption
  [  
     let to-print (list "1" simulation year who age generation skill attitude risk-aversion debt asset-value "1")
     file-open "pass-on-stats.txt"    
     file-print to-print                                                                                   
     file-close 
                     
     set generation generation + 1                                                                                        
     set age age - 30
       if age < 20 [set age 20]
     set age int age
     ;set skill precision (random-normal skill-of self 0.05)2
     ;ask farmers with [ skill > 1.2][set skill 1.2] 
     set attitude 3
     set risk-aversion 0.95
               
  ]                   
 end
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; FARM EXPANSION/CONTRACTION MODULE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to farm-expansion-contraction
 
 set plots-unsold-this-tick 0
 set plots-sold-this-tick   0
 set credit-constrained 0
 
 ask farmers [
 without-interruption
   [
                                                                          
   ask farmers with [buyer? != "seller"][screen-farmers]
   ask farmers with [buyer? = "seller"][farm-contraction] 
                                                                                      
   ]]
   
 end
 
 to screen-farmers
 
 if ((cash > (10 * acres-total-crop + 150 * mean list-of-winning-bids-adj * downpayment))                                  ;;; Liquidity check
                
                       and ((debt / asset-value) < D-A-ratio)                                                              ;;; Solvency check
                       and ((debt-payment-amount + min-family-withdrawal) < (residual-to-land-labor-exp * acres-total-crop))
                       and (age <= 55) )   
                       
                      [set buyer? "buyer" farm-expansion]
 
 end
 
 to farm-expansion
 
    set color pink
    
 end
 
 to farm-contraction
 
    without-interruption
     [        
       set color yellow                                                                                            
       if plots-owned = 1 [ask patches with [owner = who-of myself][set farmstead? false]]                                             
       
       set plot-for-sale patch-id-of min-one-of patches with [owner = who-of myself and farmstead? = false][distance-to-farmstead]     
       ask patches with [patch-id = plot-for-sale-of myself] [set for-sale? true set pcolor blue]
     ]
 
 end
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; RESERVATION PRICE CALCULATION MODULE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to reservation-price-calculation-module
 
 ifelse reservation-price?
 [
 without-interruption
 [ask patches with [for-sale? = true]
   [       
       set reservation-price 0
      
       set reservation-price precision (expected-price-per-acre-adj-p * k-acres-of self * quality-of self * 
                                        skill-of turtle owner * urgency-of turtle owner * (1 + error2-of turtle owner))2
       
       without-interruption 
       [
       let to-print (list "1" simulation year quality k-acres reservation-price "1")
       file-open "reservation-prices.txt"
       file-print to-print
       file-close 
       
       set-current-plot "Reservation Prices"
       set-current-plot-pen "reservation-price"
       plot reservation-price  
       ]
   ]
 ]]
 
 [ask patches with [for-sale? = true]
   [set reservation-price 0]
 ]  
 
 end
  
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; LAND PURCHASE AUCTION MODULE  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to land-purchase-auction-module
 
       ask farmers [set active-bidder? false]
       set current-winning-bid 0                                                                                         
       set current-winner 0                                                                                               
       set current-list-of-bids []                                                                                        
       set price-paid 0
       set auction-winner "na"
       set auction-seller "na"
       
       
 set plots-for-sale (count patches with [for-sale? = true])      
 
 ifelse count patches with [for-sale? = true] > 0 [set land-for-sale? true][set land-for-sale? false]

 if land-for-sale? = true
 [
 auction-block
 decide-to-bid
 
 ifelse bidders > 0                                                             
      [max-bid-calculation]     
      [ask patches with [on-auction-block? = true] 
        [                                                                       
          set for-sale? false 
          set current-plot-bid-on ""
          set on-auction-block? false 
          set pcolor green 
          set auction-seller "na"
          set auction-plot-acres ""
          set auction-plot-quality ""
          set xloc ""
          set yloc ""
          ask farmers with [who = owner-of myself][set buyer? "na" set color red set plot-for-sale false]
       
          set total-plots-unsold total-plots-unsold + 1
          set plots-unsold-this-tick plots-unsold-this-tick + 1
        ]
      ]
      
 ifelse bidders > 0                                     
       [compare-bids submit-highest-bid]  
       [ask patches with [on-auction-block? = true] 
          [
            set for-sale? false 
            set current-plot-bid-on ""
            set on-auction-block? false 
            set pcolor green 
            set auction-seller "na"
            set auction-plot-acres ""
            set auction-plot-quality ""
            set xloc ""
            set yloc ""
            ask farmers with [who = owner-of myself][set buyer? "na" set color red set plot-for-sale false]
       
            set total-plots-unsold total-plots-unsold + 1
            set plots-unsold-this-tick plots-unsold-this-tick + 1
         ]]       
         
       land-purchase-auction-module   
           
     ]
 
 end
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; FIND LAND AND BUYERS MODULE  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
 
 
 to auction-block
   
   ask one-of patches with [for-sale? = true] [set on-auction-block? true 
                                               set current-plot-bid-on patch-id-of self 
                                               set auction-seller owner-of self    
                                               set auction-plot-acres k-acres-of self 
                                               set auction-plot-quality quality-of self                  
                                               set xloc pxcor-of self
                                               set yloc pycor-of self
                                               watch-me] 
   
 end
 
 
 to decide-to-bid
 
   ask farmers with [buyer? = "buyer"]
     [
      set winning? false 
      set winner? false
      set credit-constrained? false
      
      set distance-to-plot-bid-on distancexy xloc yloc
      ifelse distance-to-plot-bid-on <= max-distance-travel
        [set active-bidder? true]
        [set active-bidder? false]
     ]
     
   set bidders count farmers with [active-bidder? = true] 
                                                           
 end
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; COMPARE AND SUBMIT BIDS MODULE  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 
 to compare-bids

   if bidders = 1                              
   [
   without-interruption[
    ask farmers with [active-bidder? = true][  
     
    set times-bid times-bid + 1  
    set won-last 2
    
      
            set auction-winner who-of self
            set winning? true
            set winner? true
            set current-bid ((bid + reservation-price-of patch xloc yloc) / 2)
            set highest-bid current-bid
            set price-paid current-bid 
       
    ]]]
       
   if bidders > 1
   [
   without-interruption[
   ask farmers with [active-bidder? = true][  
     
   set times-bid times-bid + 1  
   set won-last 2
   
   if Type-of-Auction = "TPSB"
     [
       
       if bidders < 3 
         [set bidders 3 set current-list-of-bids lput reservation-price-of patch xloc yloc current-list-of-bids
                        set current-list-of-bids lput reservation-price-of patch xloc yloc current-list-of-bids]
         
       let N bidders
       set bid precision(value-of-land-bid-on * ((N - 1)/(N - 2)))2
       
       ifelse bid >= max-bid 
         [set current-bid max-bid]
         [set current-bid bid] 
       
                                                                                                   
       set current-list-of-bids lput current-bid current-list-of-bids
       if current-bid > current-winning-bid 
         [ set current-winning-bid current-bid set current-winner who-of self ]
                                                                                                             
                                                           
       ifelse current-winner = who-of self                                                                                 
         [set winning? true set winner? true]
         [set winning? false set winner? false]                                                                            
         
       set highest-bid current-winning-bid
       set auction-winner current-winner
       ;;; for TPSB auction price-paid is set in the submit bids command block
       
     ]
     
   if Type-of-Auction = "FPSB"
     [
       let N bidders
       set bid precision((value-of-land-bid-on * (N - 1))/ N)2
       
       ifelse bid >= max-bid 
         [set current-bid max-bid]
         [set current-bid bid] 
       
       set current-list-of-bids lput current-bid current-list-of-bids
       if current-bid > current-winning-bid 
         [ set current-winning-bid current-bid set current-winner who-of self ]                                                                                                     
                                                           
       ifelse current-winner = who-of self                                                                                 
         [set winning? true set winner? true]
         [set winning? false set winner? false]                                                                            
         
       set highest-bid current-winning-bid
       set price-paid current-winning-bid
       set auction-winner current-winner
       
     ]
     
   if Type-of-Auction = "English"
     [       
       if value-of-land-bid-on-per-acre < max-bid-per-acre        ;;;
          [set bid value-of-land-bid-on set abs-max-bid max-bid]  ;;; 
                                                                  ;;; 
       if value-of-land-bid-on-per-acre > max-bid-per-acre        ;;; 
          [set bid max-bid set abs-max-bid max-bid]               ;;;
     
       set current-bid bid                                                                                            
              
       set current-list-of-bids lput current-bid current-list-of-bids 
       if current-bid > current-winning-bid 
         [ set second-highest-bid current-winning-bid set current-winning-bid current-bid set current-winner who-of self ]    
         
       ifelse current-winner = who-of self                                                                                 
         [set winning? true]
         [set winning? false]  
         
       set highest-bid (second-highest-bid * (1 + (minimum-bid-increment / 100))) 
                 
       
       ;;; All farmers have calculated and submitted highest bid. They now wait here until they are all done and then
       ;;; move on to the next part of the English auction below.                                    
                                           
     ]                                                             
  
   if Type-of-Auction = "SPSB"
     [    
    
      if value-of-land-bid-on-per-acre < max-bid-per-acre      ;
        [set bid value-of-land-bid-on]                         ;  
                                                               ; Bid set bid min of MaxWTP and Est. Value
      if value-of-land-bid-on-per-acre > max-bid-per-acre      ; Optimal Strategy is to "tell the truth"
        [set bid max-bid]                                      ; 
     
       set current-bid bid                                                                                           
       set current-list-of-bids lput current-bid current-list-of-bids 
       if current-bid > current-winning-bid 
         [ set second-highest-bid current-winning-bid set current-winning-bid current-bid set current-winner who-of self ]    
         
       ifelse current-winner = who-of self                                                                                 
         [set winning? true set winner? true]
         [set winning? false set winner? false]  
         
       set highest-bid current-winning-bid
       set price-paid second-highest-bid
       set auction-winner current-winner                                                                                                               
     ]  
     
 ]]]  
 
 
 
 ;;; Part two of English Auction. Begins only AFTER all first round bids have been submitted and a leader is chosen.
 
 
 
if Type-of-Auction = "English" 
[
 set current-winning-bid highest-bid
 
 ask farmers with [active-bidder? = true and abs-max-bid >= highest-bid]
 [   
     ifelse (attitude = 1 and random 100 < 20)   
          [set current-bid abs-max-bid]
          [set current-bid bid]     
          
     ifelse (attitude = 2 and random 100 < 50)   
          [set current-bid abs-max-bid]
          [set current-bid bid]      
          
     ifelse (attitude = 3 and random 100 < 80)   
          [set current-bid abs-max-bid]
          [set current-bid bid]       
 ]
    
 ;ask farmers with [active-bidder? = true and abs-max-bid >= highest-bid]
 ask farmers with [active-bidder? = true and current-bid >= highest-bid]
 [      
   without-interruption [
            set current-list-of-bids lput "X" current-list-of-bids
            set current-list-of-bids lput current-bid current-list-of-bids
            if current-bid > current-winning-bid 
              [set second-highest-bid current-winning-bid set current-winning-bid current-bid set current-winner who-of self]
              
            ifelse current-winner = who-of self                                                                                 
             [set winning? true set winner? true]
             [set winning? false set winner? false] 
            
            set highest-bid (second-highest-bid * (1 + (minimum-bid-increment / 100)))
            set price-paid highest-bid            
            set auction-winner current-winner             
          ]         
    ]
]  

 end
 
 to submit-highest-bid
 
 if Type-of-Auction = "TPSB"
   [let list-bids sort current-list-of-bids 
   set list-bids but-last list-bids 
   set list-bids but-last list-bids 
   set price-paid last list-bids]
 
 ifelse price-paid >= reservation-price-of patch xloc yloc
   [
   
       let to-print (list "1" simulation year current-plot-bid-on auction-seller auction-plot-acres
                          auction-plot-quality auction-winner highest-bid price-paid second-highest-bid "1")
       file-open "bidding-details.txt"
       file-print to-print
       file-close
       
       let to-print6 (list "1" simulation year current-plot-bid-on bidders auction-winner auction-seller reservation-price-of patch xloc yloc distance-to-plot-bid-on-of turtle auction-winner
                           max-bid-of turtle auction-winner max-bid-credit-constraint-of turtle auction-winner value-of-land-bid-on-of turtle auction-winner bid-of turtle auction-winner
                           current-bid-of turtle auction-winner abs-max-bid-of turtle auction-winner price-paid credit-constrained?-of turtle auction-winner (max-bid-of turtle auction-winner - price-paid) 
                           (price-paid - reservation-price-of patch xloc yloc) times-bid-of turtle auction-winner won-last-of turtle auction-winner "1")
       file-open "winner-details.txt"
       file-print to-print6
       file-close
                         
       
       transfer-ownership
   ]
   [
       let to-print (list "1" simulation year price-paid reservation-price-of patch xloc yloc "1")
       file-open "unmet-reservations.txt"
       file-print to-print
       file-close
       
       ask patches with [on-auction-block? = true] 
          [
            set for-sale? false 
            set current-plot-bid-on ""
            set on-auction-block? false 
            set pcolor green 
            set auction-seller "na"
            set auction-plot-acres ""
            set auction-plot-quality ""
            set xloc ""
            set yloc ""
            ask farmers with [who = owner-of myself][set buyer? "na" set color red set plot-for-sale false]
       
            set total-plots-unsold total-plots-unsold + 1
            set plots-unsold-this-tick plots-unsold-this-tick + 1
            set reservation-not-met reservation-not-met + 1
         ]
     ]   
 
 end
 

 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; BID FORMATION AND LEARNING MODULE  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
  to max-bid-calculation
 
without-interruption[
   ask farmers with [active-bidder? = true]
     [
       set upper-bound 0
       set lower-bound 0
       set max-bid 0
       set max-bid-per-acre 0
       set value-of-land-bid-on-per-acre 0
       set value-of-land-bid-on 0
       set bid 0
       set current-bid 0
       set expected-salvage-value 0
       set annuity 0
       set distance-to-plot-bid-on precision(distancexy xloc yloc)2      
       set credit-constrained? false      
              
       ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; THE FOLLOWING IS CALCULATED BASED ON QUALITY = 1, RAIN = 1, AND PLOT = 150 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       set expected-gross-rev precision (expected-price * expected-yield * 150 * 1 * risk-aversion * skill)0              
                                                                                                                  
       set expected-variable-prodn-costs precision (per-acre-vc * 150)0                                                                                                            

       set expected-hired-labour-cost precision ((((0.8 / (1 + 14500 * exp (-0.009 * 150))) + 0.03) * 150) * 6.75)0 
       
       set expected-transport-cost precision ((distance-to-plot-bid-on * travel-adjustment) + (150 * distance-to-plot-bid-on * trucking-rate * expected-yield))0
       
       set expected-capital-replacement-charge precision (capital-per-acre * depreciation-rate * 150)0
       
       set expected-netrev-per-acre precision (( expected-gross-rev 
                                               - expected-variable-prodn-costs 
                                               - expected-hired-labour-cost 
                                               - expected-transport-cost
                                               - expected-capital-replacement-charge) / 150)0                        ;;; E[Net Rev]/acre
       
       set initial-capital-investment capital-per-acre                                                               ;;; capital/acre cost of purchasing this land
       
       set expected-salvage-value precision((expected-price-per-acre-adj * skill * (1 + error2)) 
                                             / ((1 + Int-Rate) ^ (72 - age)))0                                       
       
       set annuity precision ((1 - (1 / (1 + Int-Rate) ^ (72 - age))) * (expected-netrev-per-acre / Int-Rate))0      ;;; annuity/acre
                                                                                                                     
       
       set max-bid-per-acre precision (annuity + expected-salvage-value - initial-capital-investment)2               ;;; maximum bid per acre for this particular plot of land  
                                                                                                                     ;;; based on ability to generate income from E[Y,P]             
       
       ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; NOW CALCULATE ACTUAL MAX BID BASED ON TRUE QUALITY AND K-ACRES AND RAIN = 1 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       set max-bid precision (max-bid-per-acre * auction-plot-acres * auction-plot-quality)2                         ;;; maximum bid for this particular plot of land
                                                                                                                     ;;; based on ability to generate income from E[Y,P]
                                                                                                                     
       set max-bid-credit-constraint precision ((mean list-NCFBI * ((1 - ( 1 / (1 + int-rate) ^ repayment))) / int-rate) / (1 - downpayment))2              
                                                                                                                     ;;; maximum bid for this particular plot of land                                                                                                
                                                                                                                     ;;; based on borrowing constraints
                                                                                                                     
       if max-bid-credit-constraint <= max-bid [                                                                     ;;; if credit constraints are binding adjust max-bid
                                                 set max-bid max-bid-credit-constraint                               ;;; and max-bid-per-acre
                                                 set max-bid-per-acre precision 
                                                   (max-bid / auction-plot-acres / auction-plot-quality)2
                                                 set credit-constrained? true
                                                 set credit-constrained credit-constrained + 1  
                                                ]   
                                                                                                                                                               
                                                                                                                         
       if (max-bid <= 0 or cash < (max-bid * downpayment)) [set active-bidder?  false set max-bid 0 set max-bid-per-acre 0]
                                                                                                                     ;;; check that bid is > 0 and that there is enough 
                                                                                                                     ;;; cash for a downpayment
       set bidders count farmers with [active-bidder? = true] 
       
       
    ]] 
    
 ask farmers with [active-bidder? = true][determine-land-value]
   
 end
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; LAND VALUATION MODULE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to determine-land-value
 
 set list-prices sentence local-price-info global-price-info
 set std-dev-land standard-deviation list-prices
 
 if attitude = 2 and distance-to-plot-bid-on <= 16
   [
   set upper-bound precision(expected-price-per-acre-adj + (2 * std-dev-land))2
     
   set lower-bound precision(expected-price-per-acre-adj - (2 * std-dev-land))2
   ]
 
  if attitude = 2 and distance-to-plot-bid-on > 16  
   [
   set upper-bound precision(expected-price-per-acre-adj + (1 * std-dev-land))2
     
   set lower-bound precision(expected-price-per-acre-adj - (3 * std-dev-land))2
   ]  
   
 if attitude = 1 and distance-to-plot-bid-on <= 16 
   [
   set upper-bound precision(expected-price-per-acre-adj + (1 * std-dev-land))2
     
   set lower-bound precision(expected-price-per-acre-adj - (3 * std-dev-land))2
   ]
   
 if attitude = 1 and distance-to-plot-bid-on > 16 
   [
   set upper-bound precision(expected-price-per-acre-adj + (0.3 * std-dev-land))2
     
   set lower-bound precision(expected-price-per-acre-adj - (3 * std-dev-land))2
   ]  
   
 if attitude = 3 and distance-to-plot-bid-on <= 16
   [
   set upper-bound precision(expected-price-per-acre-adj + (3 * std-dev-land))2
     
   set lower-bound precision(expected-price-per-acre-adj - (1 * std-dev-land))2
   ]  
   
if attitude = 3 and distance-to-plot-bid-on > 16
   [
   set upper-bound precision(expected-price-per-acre-adj + (2 * std-dev-land))2
     
   set lower-bound precision(expected-price-per-acre-adj - (2 * std-dev-land))2
   ]   
   
  set value-of-land-bid-on-per-acre precision (random-normal expected-price-per-acre-adj std-dev-land)2
 
       if Bid-Adjustment-Strategy = "learning-direction-theory"
          [
            if won-last = 0   [set value-of-land-bid-on-per-acre value-of-land-bid-on-per-acre]
            if won-last = 2   [set value-of-land-bid-on-per-acre precision(value-of-land-bid-on-per-acre * (1 + (bidding-adjustment / 100)))2] 
            if won-last = 1   [set value-of-land-bid-on-per-acre precision(value-of-land-bid-on-per-acre * (1 - (bidding-adjustment / 100)))2]                      
          ]                                                                                                        
          
          
 if value-of-land-bid-on-per-acre >= upper-bound
   [set value-of-land-bid-on-per-acre upper-bound]
 if value-of-land-bid-on-per-acre <= lower-bound
   [set value-of-land-bid-on-per-acre lower-bound]
 
 if (value-of-land-bid-on-per-acre <= 0) [set active-bidder?  false set max-bid 0 set value-of-land-bid-on-per-acre 0 set upper-bound 0 set lower-bound 0] 
 
 set value-of-land-bid-on precision (value-of-land-bid-on-per-acre * auction-plot-acres * auction-plot-quality)2
       
 set bidders count farmers with [active-bidder? = true] 
 
 
 end
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; LAND TRANSFER AND UPDATES  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to transfer-ownership
 
 set adj-winning-bid precision ((price-paid / auction-plot-acres) / auction-plot-quality ) 2     
 
 let to-print (list "1" simulation year adj-winning-bid "1")
 file-open "adjusted-winning-bids.txt"
 file-print to-print
 file-close
                      
 ;;; This takes the winning bid and converts it to per acre quality =1 (risk and skill = 1) 
 set list-of-winning-bids-adj fput adj-winning-bid list-of-winning-bids-adj
 set list-of-winning-bids-adj but-last list-of-winning-bids-adj
   ;;; list of winning bids decays - has memory 
 set all-prices fput adj-winning-bid all-prices      
   ;;; all-prices does not decay                                                  

 
 local-global-price-information
 
 ask turtle auction-winner                           
   [              
     set cash precision(cash - (downpayment * price-paid))0
     set debt precision(debt + ((1 - downpayment) * price-paid))0
     set principal debt
     
     refinance-debt
     
     set winning-bids fput price-paid winning-bids
     set plots-owned plots-owned + 1 
     set plots-purchased plots-purchased + 1
     set acres-total-crop acres-total-crop + k-acres-of patch xloc yloc
     set buyer? "NA" 
     set active-bidder? false 
     set winning? false 
     set winner? false 
     set color red
     set won-last 1
     capital-purchases-module
     
     set total-plots-sold total-plots-sold + 1
     set plots-sold-this-tick plots-sold-this-tick + 1  
     
     if ((cash > (10 * acres-total-crop + 150 * mean list-of-winning-bids-adj * downpayment))                                  ;;; Liquidity check
                       and ((debt / asset-value) < D-A-ratio)                                                                  ;;; Solvency check
                       and ((debt-payment-amount + min-family-withdrawal) < (residual-to-land-labor-exp * acres-total-crop))
                       and (age <= 55) )   
                       
                      [set buyer? "buyer" set color pink]   
   ]
   
 ask turtle auction-seller
   [
     set cash cash + price-paid 
     set plots-owned plots-owned - 1 
     set plots-sold plots-sold + 1 
     set acres-total-crop acres-total-crop - k-acres-of patch xloc yloc
     set plot-for-sale false 
     set buyer? "NA" 
     if breed = farmers [set color red]
   ]
   
  ask patch xloc yloc
   [
     set times-sold times-sold + 1
     set owner auction-winner 
     set for-sale? false
     set distance-to-farmstead distancexy xcor-of turtle owner ycor-of turtle owner                                 
     set current-plot-bid-on ""
     set on-auction-block? false 
     set pcolor green 
     set auction-plot-acres ""
     set auction-plot-quality ""
     set xloc ""
     set yloc ""
     
     ask turtle auction-seller
       [ determine-land-market-value
         determine-asset-value
         determine-equity-value 
         set auction-seller "na"]  
    
         
     
     set-current-plot "Winning Bids"
     set-current-plot-pen "winning-bid"
     plot price-paid
   ]                                     
                                                          
   
   ask turtles 
     [ set credit-constrained? "na"
       if plots-owned <= 0
         [
           let to-print2 (list "1" simulation year who breed age type-of-exit generation plots-sold skill attitude risk-aversion asset-value debt "1")
           file-open "exit-stats.txt"
           file-print to-print2
           file-close 
           if type-of-exit = 1 [set retired-exit retired-exit + 1]
           if type-of-exit = 2 [set voluntary-exit voluntary-exit + 1]
           if type-of-exit = 3 [set forced-exit forced-exit + 1]
           die
         ]
     ]
 
 end
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; DIFFUSION: LOCAL AND GLOBAL PRICE INFORMATION  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to local-global-price-information
 
 ask retirees[
   without-interruption[
       set local-price-info fput adj-winning-bid local-price-info
       set local-price-info but-last local-price-info
       ]]
 
 if Information-Diffusion = "on"
   [
     without-interruption
       [
         ask turtles with [active-bidder? = false]    ;;; Farmers present in auction do not get noisy price b/c they know true price
           [
             let true-price adj-winning-bid
             let X distancexy xloc yloc
             let skew one-of [1 -1]
             let error (skew * (X ^ 1 / 2))                 
             let observed-price precision(true-price + error)2
             set global-price-info fput observed-price global-price-info
             set global-price-info but-last global-price-info
           ]
       ] 
       
     ask farmers with [active-bidder?]
       [
         set local-price-info fput adj-winning-bid local-price-info
         set local-price-info but-last local-price-info
       ]     
   ]
 
 end
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; PAYMENTS AND PURCHASES MODULE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to capital-purchases-module
 
 let capital-purchase capital-per-acre * k-acres-of patch xloc yloc
 set capital-value precision(capital-value + capital-purchase)0
 set cash precision(cash - capital-purchase)0
 set capital-purchases fput capital-purchase capital-purchases
 
 determine-land-market-value
 determine-asset-value
 determine-equity-value
 
 end
 
 
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; REFINANCE DEBT MODULE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to refinance-debt
 
  
 set debt-payment-amount precision(debt * (Int-Rate / (1 - (1 / (1 + Int-Rate)^ repayment))))0
 ifelse debt > 0
   [ 
     ifelse debt > debt-payment-amount 
     [set debt-payment-amount debt-payment-amount][set debt-payment-amount debt]
   ][set debt-payment-amount 0]   
 
 end
  
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; ERROR CALCULATION ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 
 to error-calculation
 
 ask farmers
   [
     let skew one-of [1 -1]      
     if skill > 1.08 [set error2 (random-float 5 * skew) / 100]
     if skill >= 1 and skill <= 1.08 [set error2 (random-float 10 * skew) / 100]
     if skill < 1 and skill >= 0.92 [set error2 (random-float 15 * skew) / 100]
     if skill < 0.92 [set error2 (random-float 20 * skew) / 100 ] 
   ]
 end  
  
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; UPDATE DATA AND PARAMETERS  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

 to export-data
  
  ask turtles [set age age + 1]                                
  ask farmers with [cash > 0][set cash precision(cash * 1.02) 0] 
  ask farmers with [buyer? = "buyer"]
    [ set color red set buyer? "na"]    
    
  ask farmers [determine-land-market-value] 
  ask farmers [determine-asset-value]  
  ask farmers [determine-equity-value]     
  
   let to-print7 (list "1" simulation year mean values-from farmers [residual-to-land-labor-exp] mean values-from farmers [residual-to-land-labor] "1" ) 
   file-open "financial-information.txt"
   file-print to-print7
   file-close 
      
    
    without-interruption[
  ask farmers[
   let to-print (list "1" simulation year who skill acres-total-crop average-soil-quality prodn-crop crop-revenue tc-prodn debt-payment-amount 
                 family-withdrawal NCFBI principal debt asset-value cash capital-value land-value 
                 (debt / asset-value) times-bid plots-purchased plots-sold"1")
   file-open "production-information.txt"
   file-print to-print
   file-close
   ]]

  set dead (422 - (count turtles))  
  
  let to-print3 (list "1" simulation year mean values-from farmers [(debt / asset-value)] mean values-from farmers [land-value] mean values-from farmers [capital-value]
                          mean values-from farmers [cash] mean values-from farmers [debt] mean values-from farmers [acres-total-crop]
                          mean values-from farmers [skill] mean values-from farmers [ncfbi / acres-total-crop] "1")
  file-open "mean-info.txt"
  file-print to-print3
  file-close
  
  
  let to-print4 (list "1" simulation year dead retired-exit voluntary-exit forced-exit plots-sold-this-tick plots-unsold-this-tick 
                   reservation-not-met credit-constrained count farmers with [generation > 1] "1")
  file-open "general-info.txt"
  file-print to-print4
  file-close
  
  
end


 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; DELETE OUTPUT FILES ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to delete-files

if "yes" = (user-one-of
                   "Do You Want to Erase all Output Files?"
                   ["no" "yes"])
  [ delete ]

end

to delete

  file-open "pass-on-stats.txt"
  file-write ""
  file-close
  file-open "bidding-details.txt"
  file-write ""
  file-close
  file-open "exit-stats.txt"
  file-write ""
  file-close
  file-open "unmet-reservations.txt"
  file-write ""
  file-close
  file-open "reservation-prices.txt"
  file-write ""
  file-close
  file-open "adjusted-winning-bids.txt"
  file-write ""
  file-close
  file-open "financial-information.txt"
  file-write ""
  file-close
  file-open "production-information.txt"
  file-write ""
  file-close
  file-open "general-info.txt"
  file-write ""
  file-close
  file-open "mean-info.txt"
  file-print ""
  file-close
  file-open "retiree-info.txt"    
  file-print ""                                                                                
  file-close
  file-open "winner-details.txt"
  file-print ""
  file-close
  
 
  file-delete "pass-on-stats.txt"
  file-delete "bidding-details.txt"
  file-delete "exit-stats.txt"
  file-delete "unmet-reservations.txt"
  file-delete "reservation-prices.txt"
  file-delete "adjusted-winning-bids.txt"
  file-delete "financial-information.txt"
  file-delete "production-information.txt"
  file-delete "general-info.txt"
  file-delete "mean-info.txt"
  file-delete "retiree-info.txt"
  file-delete "winner-details.txt"
  
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; PREPARE OUTPUT FILES ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  to prepare-output-files
  
  file-open "pass-on-stats.txt"
  file-write (list "1" "simulation" "year" "who" "age" "generation" "skill" "attitude" "risk-aversion" "debt" "asset-value" "1")
  file-close
  file-open "bidding-details.txt"
  file-write (list "1" "simulation" "year" "current-plot-bid-on" "auction-seller" "auction-plot-acres"
                          "auction-plot-quality" "auction-winner" "highest-bid" "price-paid" "second-highest-bid" "1")
  file-close
  file-open "exit-stats.txt"
  file-write (list "1" "simulation" "year" "who" "breed" "age" "type-of-exit" "generation" "plots-sold" "skill" "attitude" "risk-aversion" "asset-value" "debt" "1")
  file-close
  file-open "unmet-reservations.txt"
  file-write (list "1" "simulation" "year" "price-paid" "reservation-price" "1")
  file-close
  file-open "reservation-prices.txt"
  file-write (list "1" "simulation" "year" "quality" "k-acres" "reservation-price" "1")
  file-close
  file-open "adjusted-winning-bids.txt"
  file-write (list "1" "simulation" "year" "adj-winning-bid" "1")
  file-close
  file-open "financial-information.txt"
  file-write (list "1" "simulation" "year" "Mean-E[PM]" "Mean-[PM]" "1" ) 
  file-close
  file-open "production-information.txt"
  file-write (list "1" "simulation" "year" "who" "skill" "acres-total-crop" "average-soil-quality" "prodn-crop" "crop-revenue" "tc-prodn" 
             "debt-payment-amount" "family-withdrawal" "NCFBI" "principal" "debt" "asset-value" "cash" "capital-value"
                  "land-value" "D/A" "times-bid" "plots-purchased" "plots-sold" "1")
  file-close
  file-open "general-info.txt"
  file-write (list "1" "simulation" "year" "dead" "retired-exit" "voluntary-exit" "forced-exit" "plots-sold" 
                  "plots-unsold" "reservation-not-met" "credit-constrained" "farmers with generation > 1" "1")
  file-close
  file-open "mean-info.txt"
  file-print (list "1" "simulation" "year" "mean-D/A" "mean-land-value" "mean-capital-value" "mean-cash" "mean-debt" "Mean-Acres-Cropped" "Mean-Skill" "Mean-NCFBI/Acre" "1")
  file-close
  file-open "retiree-info.txt"    
  file-print (list "1" "simulation" "year" "who" "age" "breed" "type-of-exit" "generation" "skill" "attitude" "plots-owned" "average-soil-quality" "risk-aversion" 
                   "debt" "asset-value" "years-neg-ncfbi" "1")                                                                              
  file-close
  
  file-open "winner-details.txt"
  file-print (list "1" "simulation" "year" "current-plot-bid-on" "bidders" "auction-winner" "auction-seller" "reservation-price" "distance-to-plot-bid-on"
                           "max-bid" "max-bid-credit-constraint" "value-of-land-bid-on" "bid" "current-bid" "abs-max-bid" "price-paid" "credit-constrained?"
                            "buyer-gain" "seller-gain" "times-bid" "won-last" "1")              
  file-close
  
  end
                          
@#$#@#$#@
GRAPHICS-WINDOW
291
10
821
561
32
32
8.0
1
2
1
1
1
0
0
0
1
-32
32
-32
32

CC-WINDOW
5
688
1511
783
Command Center
0

BUTTON
9
11
106
44
Initialization
initialization-phase-control
NIL
1
T
OBSERVER
T
NIL

SLIDER
4
279
176
312
min-family-withdrawal
min-family-withdrawal
20000
50000
30000
1
1
NIL

SLIDER
4
314
176
347
per-acre-vc
per-acre-vc
50
120
86.15
0.01
1
NIL

SLIDER
4
347
176
380
travel-adjustment
travel-adjustment
0
5
0.25
0.01
1
NIL

SLIDER
4
382
176
415
trucking-rate
trucking-rate
0
3
0.57
0.01
1
NIL

SLIDER
4
416
176
449
capital-per-acre
capital-per-acre
80
200
100
1
1
NIL

SLIDER
6
482
178
515
depreciation-rate
depreciation-rate
0
1
0.1
0.05
1
NIL

MONITOR
183
123
276
172
year
year
0
1

SLIDER
5
72
177
105
simulation-length
simulation-length
0
100
35
1
1
NIL

CHOOSER
838
319
1041
364
Type-of-Auction
Type-of-Auction
"English" "SPSB" "FPSB" "TPSB"
3

CHOOSER
839
432
1044
477
Bid-Adjustment-Strategy
Bid-Adjustment-Strategy
"no-strategy" "learning-direction-theory"
1

SLIDER
5
245
177
278
max-distance-travel
max-distance-travel
0
100
25
1
1
NIL

BUTTON
109
11
184
44
GO
simulation-phase
NIL
1
T
OBSERVER
T
NIL

SLIDER
6
517
178
550
Int-Rate
Int-Rate
0
1
0.08
0.01
1
NIL

MONITOR
184
174
276
223
Active Bidders
bidders
0
1

MONITOR
184
323
277
372
Exit
dead
0
1

PLOT
839
10
1039
160
Winning Bids
Plots Sold
Bids
0.0
10.0
0.0
10.0
true
false
PENS
"winning-bid" 1.0 0 -16777216 true

SLIDER
838
161
1043
194
retirement-tendency-55-59
retirement-tendency-55-59
0
1
0.03
0.01
1
NIL

SLIDER
840
195
1045
228
retirement-tendency-60-64
retirement-tendency-60-64
0
1
0.06
0.01
1
NIL

SLIDER
1044
160
1249
193
retirement-tendency-65-69
retirement-tendency-65-69
0
1
0.1
0.01
1
NIL

SLIDER
1045
194
1251
227
retirement-tendency-70-over
retirement-tendency-70-over
0
1
0.2
0.01
1
NIL

MONITOR
184
224
276
273
Plots for Sale
plots-for-sale
0
1

SLIDER
5
211
177
244
percentage-retired
percentage-retired
0
1
0.0
0.01
1
NIL

MONITOR
184
274
277
323
Seller
auction-seller
0
1

PLOT
1040
11
1233
161
Reservation Prices
Plots for Sale
Res. Price
0.0
10.0
0.0
10.0
true
false
PENS
"reservation-price" 1.0 0 -2674135 true

BUTTON
186
11
281
44
Delete Files
delete-files
NIL
1
T
OBSERVER
T
NIL

SLIDER
839
477
1044
510
bidding-adjustment
bidding-adjustment
0
100
5
1
1
%

CHOOSER
839
510
1046
555
Information-Diffusion
Information-Diffusion
"on" "off"
0

SLIDER
1062
320
1234
353
downpayment
downpayment
0
1
0.25
0.01
1
NIL

SLIDER
1063
353
1235
386
D-A-ratio
D-A-ratio
0
1
0.4
0.01
1
NIL

SLIDER
838
398
1043
431
minimum-bid-increment
minimum-bid-increment
0
100
5
1
1
%

TEXTBOX
1089
300
1239
318
           Financials

MONITOR
186
383
269
432
Retired  Exits
retired-exit
0
1

MONITOR
186
480
269
529
Voluntary Exits
voluntary-exit
0
1

MONITOR
186
432
270
481
Forced Exits
forced-exit
0
1

SLIDER
5
449
177
482
cash-per-acre
cash-per-acre
0
250
75
1
1
NIL

SWITCH
838
364
1043
397
reservation-price?
reservation-price?
0
1
-1000

SLIDER
6
106
178
139
number-of-simulations
number-of-simulations
1
100
100
1
1
NIL

MONITOR
184
73
276
122
Simulation
simulation
0
1

SLIDER
942
230
1146
263
percent-pass-down
percent-pass-down
0
100
65
1
1
%

SLIDER
3
178
178
211
expectation-weight
expectation-weight
0
1
0.1
0.0010
1
NIL

SLIDER
1064
386
1236
419
repayment
repayment
0
100
20
1
1
NIL

@#$#@#$#@
WHAT IS IT?
-----------
The model explores and understands the effects of agent interactions, information feedback, and adaptive learning in a repeated game of bidding in farmland auction markets. It gathers information for three types of sealed-bid auctions, and one English auction and compares them on the basis of efficiency, price information revelation, and the ability to deal with repeated bidding and agent learning.


HOW IT WORKS
------------
Farmers are the first breed of agents. Farm agents are assumed to produce crops on their land and sell them at market price. All farmers less than a threshold age are assumed to want to expand their farm size by purchasing land from farmers who are exiting the market. This model assumes there is no leased land or leasing market. Farmers seek to invest positive income streams by purchasing land at the lowest price possible, farming it until they exit, and then selling their land at the highest price possible through specified auction markets. Farm agents farm all the land they own in each period until they are either forced out of the market for credit reasons, equity protection, or old age. A random percentage of farmers pass down their land to an heir if the farm is financially viable. Furthermore, farm agents are assumed to be rational and act upon the best information available to them. 


HOW TO USE IT
-------------
All model parameters are described in Arsenault (2007). 

Interface

simulation-length: number of years the model runs

number-of-simulations: the number of replications of the model

expectation-weight: agents form expectations about future prices and yields, and the    future price of land. Since the full value of a capital asset is based on future income stream, it is not possible for agents to know the true value of any plot of land until it is sold. An expectation weight is calculated by (1 - expectation-weight).

percentage-retired: number of farmers that are forced to retire each year

max-distance-travel: straight-line distance measuring the furthest an agent will travel

min-family-withdrawal: amount, in dollars, that is withdrawn as family living expense

per-acre-vc: per acre variable cost

travel-adjustment: cost of transporting machinery between plots ($/mile)

trucking-rate: cost of transporting grain ($/tonne-mile)

capital-per-acre: annual cost of capital replacement (investment in  machinery, buildings, and equipment) per cultivated acre

cash-per-acre: cash on hand per cultivatable acre

depreciation-rate: rate of economic depreciation

Int-Rate: interest rate loans are given at

retirement-tendency-55-59: likelihood of retirement of farmers within this age category

retirement-tendency-60-64: likelihood of retirement of farmers within this age category

retirement-tendency-65-69: likelihood of retirement of farmers within this age category

retirement-tendency-70-over: likelihood of retirement of farmers within this age category

percent-pass-down: threshold for a random number of farmers to pass land onto the next generation

minimum-bid-increment: used to calculate the highest bid

bidding-adjustment: bid is adjusted depending on success of prior bids (as part of learning-direction-theory)

Type-of-Action: English; SPSB (Second Price Sealed Bid); FPSB (First Price Sealed Bid); TPSB (Third Price Sealed Bid)

Bid-Adjustment-Strategy: No strategy; learning-direction-theory

Information-Diffusion: On; Off

reservation-price?: On; Off

down-payment: percentage paid down on initial land loan amount

D-A-ratio: debt to asset ratio

repayment: loan life


THINGS TO NOTICE
----------------
As the model runs, a highlighted area shows where auctions occur. 


THINGS TO TRY
-------------
Choosers for the type of auction will call different procedures to yield different outcomes from the model. The expectation-weight, minimum-bid-increment, and bidding-adjustment can be moved to observe different behaviors. The other sliders are exogenous variables.


RELATED MODELS
--------------
This model built off of the work done by Tyler Freeman's thesis titled "From the Ground Up: An Agent-Based Model of Regional Structural Change" (September 2005, University of Saskatchewan)


CREDITS AND REFERENCES
----------------------
Arsenault, Adam M. 2007. A Multi-Agent Simulation Approach to Farmland Auction Markets: Repeated Games with Agents that Learn. Thesis. Department of Agricultural Economics. University of Saskatchewan. September. Saskatoon, Saskatchewan. 
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

link
true
0
Line -7500403 true 150 0 150 300

link direction
true
0
Line -7500403 true 150 150 30 225
Line -7500403 true 150 150 270 225

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 3.1.5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
